//+------------------------------------------------------------------+
//|                                             Donchian Std Dev.mq4 |
//|                         
//|                                                 
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 5
#property  indicator_color1  Tomato
#property  indicator_color2  Tomato
#property  indicator_color3  Green
#property  indicator_color4  Green
#property  indicator_color5  Black
#property  indicator_width1  1
#property  indicator_width2  1
 
//---- indicator parameters
extern int periods=13;
extern int shift=0; 
extern int BandPeriod = 21;
extern double const=  1.3;
//---- indicator buffers
double     upper[];
double     lower[];
double     upDev[];
double     loDev[];
double     center[]; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(Digits);   
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);   
      
//---- indicator buffers mapping
   SetIndexBuffer(0,upper);
   SetIndexBuffer(1,lower);
   SetIndexBuffer(2,upDev);
   SetIndexBuffer(3,loDev);      
   SetIndexBuffer(4,center);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Donchian Channel("+periods+")");
   SetIndexLabel(0,"Upper");
   SetIndexLabel(1,"Lower");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| now do the dance.                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double up,dn,ctr;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
 
//---- calculate values
   for(int i=0; i<limit; i++) 
   {
      up=iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,periods,i+shift));
      dn=iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,periods,i+shift));
      upper[i]=up;
      lower[i]=dn;
      ctr=up-MathAbs((up-dn)/2);
      center[i]=ctr;
   }
   for(i=0; i<limit; i++) 
   {
      upDev[i]=center[i]+(const * StDev(center,BandPeriod));
      loDev[i]=center[i]-(const * StDev(center,BandPeriod));
   }   
      
   return(0);
  }
  
double StDev(double& Data[], int Per)
{
  return(MathSqrt(Variance(Data,Per)));
}

double Variance(double& Data[], int Per)
{
  double sum, ssum;
  for (int i=0; i<Per; i++)
  {
    sum += Data[i];
    ssum += MathPow(Data[i],2);
  }
  return((ssum*Per - sum*sum)/(Per*(Per-1)));
}
//+------------------------------------------------------------------+  